﻿@page "/"
@using Entities
@using System.Collections;
@using System.Data;
@using System.Linq;
@using Microsoft.Data.SqlClient;
@using Dapper;
@using Blazorise;
@using BlazorApp.Logic;

@inject Toolbelt.Blazor.I18nText.I18nText I18nText
@inject IJSRuntime jsRuntime

<style>
#draggable {
    margin-bottom: 10px;
    padding: 10px 25px;
    border: 1px solid #424d5c;
    cursor: grab;
    background: #5c6b7f;
    color: #ffffff;
    border-radius: 5px;
    width: 250px;
}
  #sortable { list-style-type: none; margin: 0; padding: 0; width: 450px; }
  #draggable li { margin: 3px 3px 3px 0; padding: 1px; float: left; width: 100px; height: 90px; font-size: 4em; text-align: center; }
 </style>

<EditForm Model="@v" style ="form-control">
<h3>@MyText.Titolo</h3>
<div class="card" style="width: 100%;">
        <div class="card-body">
        <h5 class="card-title">@MyText.SelezioneBase</h5>
    <div class="form-group">
    <div class="form-group" style ="padding-top: 10px; text-align: center;">
        <RadioGroup TValue="bool" Name="Trasmissione" Inline = "true" @bind-CheckedValue="@v.Trasmissione">
            <Radio TValue="bool" Value="@true"> @MyText.TrasmSi</Radio>
            <Radio TValue="bool" Value="@false"> @MyText.TrasmNo</Radio>
        </RadioGroup>
    </div>
    <Select @bind-SelectedValue="v.Serie" class ="form-control">
        <option>@MyText.SelezionaSerie</option>
        @foreach (string s in serie)
        {
            <option value=@s>@s</option>
        }
    </Select>
    <div style="padding-top: 10px">
        <Select @bind-SelectedValue="v.Modello">
            <option>@MyText.SelezionaModello</option>
            @foreach (VentilatoreSQL vent in list.FindAll(x => x.Serie.Equals(v.Serie)))
            {
                    <option value=@vent.Modello>@vent.Modello</option>
            }
        </Select>
    </div>
    </div>
        <div style ="display:flex; padding-top: 10px; ">
            <div style ="padding-right: 5px; width: 50%">
            <Select @bind-SelectedValue="v.Esecuzione">
                <option>@MyText.SelezionaEsecuzione</option>
                    @if (v.Trasmissione)
                        {
                            @foreach (string s in v.EsecuzioniTrasmissione)
                            {<option value=@s>@s</option>}
                        }
                        else {
                            @foreach (string s in v.EsecuzioniDirette)
                            {<option value=@s>@s</option>}
                        }
            </Select>
            </div>
            <div style ="width: 50%">
                <Select @bind-SelectedValue="v.Rotazione">
                    <option>@MyText.SelezionaRotazione</option>
                    <option value = "0">R0</option>
                    <option value = "1">R90</option>
                    <option value = "2">R180</option>
                    <option value = "3">R270</option>
                </Select>
            </div>
        </div>
    <div class="form-group">
 </div></div>
    </div>
        <div class="card" style="width: 100%;">
        <div class="card-body">
        <h5 class="card-title">@MyText.AccessoriAspirazione</h5>
        @{
            <Row>
            @foreach(Accessorio acc in v.AccessoriAspirazione)
            {
                <Column ColumnSize="ColumnSize.Is3">
                    <Addons style="padding-top:4px">
                        <Addon AddonType="AddonType.Start" style ="width:40%">
                            <AddonLabel style ="width:100%">@acc.Codice</AddonLabel>
                        </Addon>
                        <Addon AddonType="AddonType.Body" >
                            <InputNumber @bind-Value="@acc.Quantita" Min="0" style ="width:60%"/>
                        </Addon>
                    </Addons>
                </Column>
            }
            </Row>
        }
        <div style ="padding-top:10px"> 
        <Button Color="Color.Light" Clicked="@ConfermaAspirazione" >@MyText.ConfermaSelezione</Button>
        </div>
        <div style="margin-top: 10px; padding:10px; border: 1px solid lightgrey">
            <h6 class="card-title" >@MyText.MettiInOrdine</h6>
            <ul ondragover="event.preventDefault();" style="margin:20px; display:flex; padding-left:0px">
                @foreach (Accessorio item in v.AccessoriAspirazioneOrdinati)
                {
                    if(item != null)
                    {
                        <li class="flex-item" draggable="true" style="list-style-type:none; " @key="item.Id" tabindex="1"
                                @ondrop="@(()=> Drop(item))" @ondrag="@(()=> StartDrag(item))" @onclick="@(()=> ClickItem(item))">
                            <span>@item.Codice</span>
                        </li>
                    } else 
                    {
                        <li>NULL??</li>
                    }
                }
             </ul>
         </div>
    </div>
    </div>
        <div class="card" style="width: 100%;">
        <div class="card-body">
        <h5 class="card-title">@MyText.AccessoriMandata</h5>
        @{
            <Row>
            @foreach(Accessorio acc in v.AccessoriMandata)
            {
                <Column ColumnSize="ColumnSize.Is3">
                    <Addons style="padding-top:4px">
                        <Addon AddonType="AddonType.Start" style ="width:40%">
                            <AddonLabel style ="width:100%">@acc.Codice</AddonLabel>
                        </Addon>
                        <Addon AddonType="AddonType.Body" >
                            <InputNumber @bind-Value="@acc.Quantita" Min="0" style ="width:60%"/>
                        </Addon>
                    </Addons>
                </Column>
            }
            </Row>
        }
        <div style ="padding-top:10px"> 
        <Button Color="Color.Light" Clicked="@ConfermaMandata" >@MyText.ConfermaSelezione</Button>
        </div>
        <div style="margin-top: 10px; padding:10px; border: 1px solid lightgrey">
            <h6 class="card-title" >@MyText.MettiInOrdine</h6>
            <ul ondragover="event.preventDefault();" style="margin:20px; display:flex; padding-left:0px">
                @foreach (Accessorio item in v.AccessoriMandataOrdinati)
                {
                    if(item != null)
                    {
                        <li class="flex-item" draggable="true" style="list-style-type:none; " @key="item.Id" tabindex="1"
                                @ondrop="@(()=> Drop(item))" @ondrag="@(()=> StartDrag(item))" @onclick="@(()=> ClickItem(item))">
                            <span>@item.Codice</span>
                        </li>
                    } else 
                    {
                        <li>NULL??</li>
                    }
                }
             </ul>
         </div>
    </div>
</div>
</EditForm>
<Button Clicked="@OnButtonClicked" Color="Color.Info">@MyText.SelezioneCompletata</Button>

@code
{   private static readonly ILog _log = LogManager.GetLogger(MethodBase.GetCurrentMethod().DeclaringType);
    int currentIndex;
    I18nText.testi MyText = new I18nText.testi();
    VentilatoreSQL v = new VentilatoreSQL();
    ArrayList serie = new ArrayList();
    List<VentilatoreSQL> list = new List<VentilatoreSQL>();
    List<VentilatoreSQL> listFiltered = new List<VentilatoreSQL>();
 
    protected override async Task OnInitializedAsync()
    {
        XmlConfigurator.Configure();
        MyText = await I18nText.GetTextTableAsync<I18nText.testi>(this);
        v.init();
        ReadAll();
    }

    public void ConfermaMandata() 
    {
        CreateCompleteList(v.AccessoriMandata, false);
    }

    public void ConfermaAspirazione() 
    {
        CreateCompleteList(v.AccessoriAspirazione, true);
    }

    public void ReadAll()
    {
         using (IDbConnection db = new SqlConnection(Properties.Resources.Connection))
         {
             list = db.Query<VentilatoreSQL> ("Select * From Modelli").ToList();
         }
         foreach (VentilatoreSQL vent in list)
         {
             if (!serie.Contains(vent.Serie))
             {
                 serie.Add(vent.Serie);
             }
         }
    }

    public void CreateCompleteList(List<Accessorio> lista, bool aspirazione) {
        List<Accessorio> result = new List<Accessorio>();
        int id = 0;
        foreach (Accessorio accessorio in lista) {
            for (int i = 0; i < accessorio.Quantita; i++) {
                Accessorio newAcc = accessorio.Clone();
                newAcc.Id = id++;
                result.Add(newAcc);
            }
        }
        if (aspirazione)
            v.AccessoriAspirazioneOrdinati = result;
        else
            v.AccessoriMandataOrdinati = result;
    }
     
    void StartDrag(Accessorio item)
    {
        currentIndex = GetIndex(item);
        Console.WriteLine($"DragStart for {item.Id} index {currentIndex}");
    }

    void ClickItem(Accessorio item)
    {
        currentIndex = GetIndex(item);
    }

    int GetIndex(Accessorio item)
    {
        if (item.Direzione.Equals("Mandata"))
            return v.AccessoriMandataOrdinati.FindIndex(a => a.Id == item.Id);
        else
            return v.AccessoriAspirazioneOrdinati.FindIndex(a => a.Id == item.Id);
    }

    void Drop(Accessorio item)
    {
        if (item != null)
        {
            Console.WriteLine($"Drop item {item.Codice} ({item.Id})");
            var posizioneDrop = GetIndex(item);
            Console.WriteLine($"Drop index is {posizioneDrop}, move from {currentIndex}");
            if (item.Direzione.Equals("Mandata")) {
                var current = v.AccessoriMandataOrdinati[currentIndex];
                v.AccessoriMandataOrdinati.RemoveAt(currentIndex);
                v.AccessoriMandataOrdinati.Insert(posizioneDrop, current);
            }
            else {
                var current = v.AccessoriAspirazioneOrdinati[currentIndex];
                v.AccessoriAspirazioneOrdinati.RemoveAt(currentIndex);
                v.AccessoriAspirazioneOrdinati.Insert(posizioneDrop, current);
            }
            currentIndex = posizioneDrop;
            StateHasChanged();
        } 
        else
        {
            Console.WriteLine("Drop - null");
        }
    }

    void ReportList()
    {
        int i =0;
        foreach (var item in v.AccessoriMandataOrdinati)
        {
            Console.WriteLine($"{i++}: {item.Id} = {item.Codice}");
        }
    }

    public void OnButtonClicked() {
        _log.Info("Richiesta Modello Inviata");
        JsonGenerator xml = new JsonGenerator(v, _log);
        xml.generaJSon();
    }


}
